/* $Id: seq.h,v 1.2 2002/07/24 10:10:20 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SEQ_H
#define SEQ_H

#include "dstring.h"
#include "interp.h"

#ifndef SEQ_IMP
extern storage_class seq_storage_class;
#endif

storage *seq_create(interpreter *i, char *name, char *arg);

void seq_destroy(interpreter *i, storage *s);

int seq_check(interpreter *i, storage *s, dstring *key);
dstring *seq_get(interpreter *i, storage *s, dstring *key);

void seq_put(interpreter *i, storage *s, dstring *key, dstring *val);
void seq_add(interpreter *i, storage *s, dstring *key, dstring *val);

void seq_remove(interpreter *i, storage *s, dstring *key);

dstring *seq_first(interpreter *i, storage *s, void **iter);
dstring *seq_next(interpreter *i, storage *s, void **iter);
void seq_enditer(interpreter *i, storage *s, void **iter);

int seq_numofitems(interpreter *i, storage *s);

#endif
